--- old/build/openssh/patches/0003-lastlogin.patch	Wed Feb 10 16:25:00 2016
+++ /dev/null	Wed Feb 10 16:25:00 2016
@@ -1,69 +0,0 @@
-From f0ec680c71b9c2f0c2d729d58231dca27593a5b4 Mon Sep 17 00:00:00 2001
-From: oracle <solaris@oracle.com>
-Date: Mon, 3 Aug 2015 14:34:41 -0700
-Subject: [PATCH 03/30] lastlogin
-
-# The man page change here is Solaris-specific and thus is not being
-# contributed back to the upstream community.  The servconf.c change
-# was developed in-house and has been submitted upstream to OpenSSH for
-# their consideration:
-# https://bugzilla.mindrot.org/show_bug.cgi?id=2278
-#
-# OpenSSH normally updates lastlog when users login and reads lastlog to
-# determine the last login time of the user however on Solaris the
-# pam_unix_session(5) module handles both of these tasks so we compile
-# OpenSSH with --disable-lastlog to disable all lastlog references.
-# This means the sshd_config option of PrintLastLog is now ignored and
-# can't be changed so we update sshd's configuration parsing to flag
-# this as unsupported and update the man page here.
-#
-*** old/servconf.c Wed Sep 17 02:54:26 2014
----
- servconf.c    | 4 ++++
- sshd_config.5 | 7 ++++---
- 2 files changed, 8 insertions(+), 3 deletions(-)
-
-diff --git a/servconf.c b/servconf.c
-index 5e8ed97..4ec6b57 100644
---- a/servconf.c
-+++ b/servconf.c
-@@ -504,7 +504,11 @@ static struct {
- 	{ "listenaddress", sListenAddress, SSHCFG_GLOBAL },
- 	{ "addressfamily", sAddressFamily, SSHCFG_GLOBAL },
- 	{ "printmotd", sPrintMotd, SSHCFG_GLOBAL },
-+#ifdef DISABLE_LASTLOG
-+	{ "printlastlog", sUnsupported, SSHCFG_GLOBAL },
-+#else
- 	{ "printlastlog", sPrintLastLog, SSHCFG_GLOBAL },
-+#endif
- 	{ "ignorerhosts", sIgnoreRhosts, SSHCFG_GLOBAL },
- 	{ "ignoreuserknownhosts", sIgnoreUserKnownHosts, SSHCFG_GLOBAL },
- 	{ "x11forwarding", sX11Forwarding, SSHCFG_ALL },
-diff --git a/sshd_config.5 b/sshd_config.5
-index b18d340..476f71c 100644
---- a/sshd_config.5
-+++ b/sshd_config.5
-@@ -1300,8 +1300,8 @@ Specifies whether
- .Xr sshd 8
- should print the date and time of the last user login when a user logs
- in interactively.
--The default is
--.Dq yes .
-+On Solaris this option is always ignored since pam_unix_session(5)
-+reports the last login time.
- .It Cm PrintMotd
- Specifies whether
- .Xr sshd 8
-@@ -1721,7 +1721,8 @@ This file should be writable by root only, but it is recommended
- (though not necessary) that it be world-readable.
- .El
- .Sh SEE ALSO
--.Xr sshd 8
-+.Xr sshd 8 ,
-+.Xr pam_unix_session 5
- .Sh AUTHORS
- OpenSSH is a derivative of the original and free
- ssh 1.2.12 release by Tatu Ylonen.
--- 
-2.3.2 (Apple Git-55)
-
--- /dev/null	Wed Feb 10 16:25:00 2016
+++ new/build/openssh/patches/0005-lastlogin.patch	Wed Feb 10 16:25:00 2016
@@ -0,0 +1,69 @@
+From 1bcd61d5d1b9cec96dbbe7254758cb97e60779d0 Mon Sep 17 00:00:00 2001
+From: oracle <solaris@oracle.com>
+Date: Mon, 3 Aug 2015 14:34:41 -0700
+Subject: [PATCH 05/36] lastlogin
+
+# The man page change here is Solaris-specific and thus is not being
+# contributed back to the upstream community.  The servconf.c change
+# was developed in-house and has been submitted upstream to OpenSSH for
+# their consideration:
+# https://bugzilla.mindrot.org/show_bug.cgi?id=2278
+#
+# OpenSSH normally updates lastlog when users login and reads lastlog to
+# determine the last login time of the user however on Solaris the
+# pam_unix_session(5) module handles both of these tasks so we compile
+# OpenSSH with --disable-lastlog to disable all lastlog references.
+# This means the sshd_config option of PrintLastLog is now ignored and
+# can't be changed so we update sshd's configuration parsing to flag
+# this as unsupported and update the man page here.
+#
+*** old/servconf.c Wed Sep 17 02:54:26 2014
+---
+ servconf.c    | 4 ++++
+ sshd_config.5 | 7 ++++---
+ 2 files changed, 8 insertions(+), 3 deletions(-)
+
+diff --git a/servconf.c b/servconf.c
+index 5e8ed97..4ec6b57 100644
+--- a/servconf.c
++++ b/servconf.c
+@@ -504,7 +504,11 @@ static struct {
+ 	{ "listenaddress", sListenAddress, SSHCFG_GLOBAL },
+ 	{ "addressfamily", sAddressFamily, SSHCFG_GLOBAL },
+ 	{ "printmotd", sPrintMotd, SSHCFG_GLOBAL },
++#ifdef DISABLE_LASTLOG
++	{ "printlastlog", sUnsupported, SSHCFG_GLOBAL },
++#else
+ 	{ "printlastlog", sPrintLastLog, SSHCFG_GLOBAL },
++#endif
+ 	{ "ignorerhosts", sIgnoreRhosts, SSHCFG_GLOBAL },
+ 	{ "ignoreuserknownhosts", sIgnoreUserKnownHosts, SSHCFG_GLOBAL },
+ 	{ "x11forwarding", sX11Forwarding, SSHCFG_ALL },
+diff --git a/sshd_config.5 b/sshd_config.5
+index b18d340..476f71c 100644
+--- a/sshd_config.5
++++ b/sshd_config.5
+@@ -1300,8 +1300,8 @@ Specifies whether
+ .Xr sshd 8
+ should print the date and time of the last user login when a user logs
+ in interactively.
+-The default is
+-.Dq yes .
++On Solaris this option is always ignored since pam_unix_session(5)
++reports the last login time.
+ .It Cm PrintMotd
+ Specifies whether
+ .Xr sshd 8
+@@ -1721,7 +1721,8 @@ This file should be writable by root only, but it is recommended
+ (though not necessary) that it be world-readable.
+ .El
+ .Sh SEE ALSO
+-.Xr sshd 8
++.Xr sshd 8 ,
++.Xr pam_unix_session 5
+ .Sh AUTHORS
+ OpenSSH is a derivative of the original and free
+ ssh 1.2.12 release by Tatu Ylonen.
+-- 
+2.5.4 (Apple Git-61)
+