--- /dev/null	Wed Feb 10 16:25:01 2016
+++ new/build/openssh/patches/0013-SunSSH-compat-default-config-values.patch	Wed Feb 10 16:25:01 2016
@@ -0,0 +1,135 @@
+From 6286276c8442faf6514f8f8a6ba5993193fb28bb Mon Sep 17 00:00:00 2001
+From: oracle <solaris@oracle.com>
+Date: Mon, 3 Aug 2015 14:36:22 -0700
+Subject: [PATCH 13/36] SunSSH compat default config values
+
+#
+# Some options in OpenSSH have different default values from those in SunSSH.
+# To make the transition smoother from SunSSH to OpenSSH, we change default
+# values for the following options to be as same as those in SunSSH.
+#
+#   GSSAPIAuthentication (for both server and client)
+#   X11Forwarding        (for server)
+#   ForwardX11Trusted    (for client)
+#
+# This is for Solaris only, we will not contribute back these changes to the
+# upstream.
+#
+---
+ readconf.c    | 8 ++++++++
+ servconf.c    | 8 ++++++++
+ ssh_config.4  | 8 ++++----
+ sshd_config.4 | 8 ++++----
+ 4 files changed, 24 insertions(+), 8 deletions(-)
+
+diff --git a/readconf.c b/readconf.c
+index d0f4068..db37809 100644
+--- a/readconf.c
++++ b/readconf.c
+@@ -1751,7 +1751,11 @@ fill_default_options(Options * options)
+ 	if (options->forward_x11 == -1)
+ 		options->forward_x11 = 0;
+ 	if (options->forward_x11_trusted == -1)
++#ifdef OPTION_DEFAULT_VALUE
++		options->forward_x11_trusted = 1;
++#else
+ 		options->forward_x11_trusted = 0;
++#endif
+ 	if (options->forward_x11_timeout == -1)
+ 		options->forward_x11_timeout = 1200;
+ 	if (options->exit_on_forward_failure == -1)
+@@ -1773,7 +1777,11 @@ fill_default_options(Options * options)
+ 	if (options->challenge_response_authentication == -1)
+ 		options->challenge_response_authentication = 1;
+ 	if (options->gss_authentication == -1)
++#ifdef OPTION_DEFAULT_VALUE
++		options->gss_authentication = 1;
++#else
+ 		options->gss_authentication = 0;
++#endif
+ 	if (options->gss_deleg_creds == -1)
+ 		options->gss_deleg_creds = 0;
+ 	if (options->password_authentication == -1)
+diff --git a/servconf.c b/servconf.c
+index d0ca777..dab8945 100644
+--- a/servconf.c
++++ b/servconf.c
+@@ -251,7 +251,11 @@ fill_default_server_options(ServerOptions *options)
+ 	if (options->print_lastlog == -1)
+ 		options->print_lastlog = 1;
+ 	if (options->x11_forwarding == -1)
++#ifdef OPTION_DEFAULT_VALUE
++		options->x11_forwarding = 1;
++#else
+ 		options->x11_forwarding = 0;
++#endif
+ 	if (options->x11_display_offset == -1)
+ 		options->x11_display_offset = 10;
+ 	if (options->x11_use_localhost == -1)
+@@ -291,7 +295,11 @@ fill_default_server_options(ServerOptions *options)
+ 	if (options->kerberos_get_afs_token == -1)
+ 		options->kerberos_get_afs_token = 0;
+ 	if (options->gss_authentication == -1)
++#ifdef OPTION_DEFAULT_VALUE
++		options->gss_authentication = 1;
++#else
+ 		options->gss_authentication = 0;
++#endif
+ 	if (options->gss_cleanup_creds == -1)
+ 		options->gss_cleanup_creds = 1;
+ 	if (options->gss_strict_acceptor == -1)
+diff --git a/ssh_config.4 b/ssh_config.4
+index 6325b3a..720451e 100644
+--- a/ssh_config.4
++++ b/ssh_config.4
+@@ -724,8 +724,8 @@ Furthermore, the
+ token used for the session will be set to expire after 20 minutes.
+ Remote clients will be refused access after this time.
+ .Pp
+-The default is
+-.Dq no .
++The default on Solaris is
++.Dq yes .
+ .Pp
+ See the X11 SECURITY extension specification for full details on
+ the restrictions imposed on untrusted clients.
+@@ -754,8 +754,8 @@ The default is
+ .Pa /etc/ssh/ssh_known_hosts2 .
+ .It Cm GSSAPIAuthentication
+ Specifies whether user authentication based on GSSAPI is allowed.
+-The default is
+-.Dq no .
++The default on Solaris is
++.Dq yes .
+ Note that this option applies to protocol version 2 only.
+ .It Cm GSSAPIDelegateCredentials
+ Forward (delegate) credentials to the server.
+diff --git a/sshd_config.4 b/sshd_config.4
+index 263175b..03c5b52 100644
+--- a/sshd_config.4
++++ b/sshd_config.4
+@@ -618,8 +618,8 @@ The default is
+ .Dq no .
+ .It Cm GSSAPIAuthentication
+ Specifies whether user authentication based on GSSAPI is allowed.
+-The default is
+-.Dq no .
++The default on Solaris is
++.Dq yes .
+ Note that this option applies to protocol version 2 only.
+ .It Cm GSSAPICleanupCredentials
+ Specifies whether to automatically destroy the user's credentials cache
+@@ -1623,8 +1623,8 @@ The argument must be
+ .Dq yes
+ or
+ .Dq no .
+-The default is
+-.Dq no .
++The default on Solaris is
++.Dq yes .
+ .Pp
+ When X11 forwarding is enabled, there may be additional exposure to
+ the server and to client displays if the
+-- 
+2.5.4 (Apple Git-61)
+